/*=====================================================================
CASIO 3.1


 All these routines works with Video Pages to work with Multi-Buffering
    Part of Na-Prod Casio Project & CDK & Graph100 French Network
  Thanks to Whyp, 2072, BradN, Y@SS, Bugbug, Libthium, Duobab, Roeoender
  	New Pixel Routines by SUPERNA, 27% faster than old ones
   New exclusives routines : Time, date, contrast, On/Off and Reboot !
 	See .doc for help and examples or www.na-prod.com

======================================================================*/

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include "CASIO31.h"

/*==============================================================
in :	coordones
		page (1 -> 4)
		couleur 1=> noir, 0=> Blanc
out:
rem:	affiche un pixel aux coordones spcifie et avec la
		couleur spcifie
by :	Whyp et Superna
===============================================================*/
#ifdef KFUNC_CASIO_setPix
void setPix(short X,short Y,short page,unsigned char couleur){
asm {
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63
	mov cx,127
	sub si,Y //On copie y   //4
	sub cx,X //On copie x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov al,couleur
	mov bl,es:[si] // Recupere le byte a changer
	db 0x0F,0x12,0x0C3      // clr1 bl,cl (specifique au nec v20/30)
	rol al,cl		// met le 1 (si 1) a la place voulue
	or bl,al		// Ecris le 1 (si 1)
	mov es:[si],bl };}	// Remet le byte
#endif

/*==============================================================
in :	coordones
		page (1 -> 4)
out:
rem:	affiche un pixel noir aux coordonnes spcifi
by :	Superna
===============================================================*/
#ifdef KFUNC_CASIO_setbPix
void setbPix(short x,short y,short page){
asm{
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63
	mov cx,127
	sub si,y //On copie y   //4
	sub cx,x //On copie x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov ch,1   //On met le state    //2
	shl ch,cl     //on le deplace selon cl //3
	or es:[si],ch}}; //On l'applique a l'octet //7// Remet le byte
#endif

/*==============================================================
in :	coordones
		page (1 -> 4)
out:
rem:	affiche un pixel blanc aux coordonnes spcifi
by :	Superna
===============================================================*/
#ifdef KFUNC_CASIO_setwPix
void setwPix(int x,int y,int page){
asm{
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //On copie y   //4
	mov cx,127 //On copie x   //4
	sub si,y //on enleve y
	sub cx,x //on enleve x
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov ch,es:[si] //On prends l'octet //4
	mov bl,0x01  //On met 1 //2
	shl bl,cl    //On le deplace //3
	and bl,ch    //On prends le bit si il existe //2
	xor es:[si],bl}}; //On l'applique a l'octet //7
#endif

/*==============================================================
in :	coordones
		page (1 -> 4)
out:
rem:	inverce le pixel aux coordonnes spcifi
by :	Superna
===============================================================*/
#ifdef KFUNC_CASIO_invpixel
void invpixel(int x,int y,int page){
asm{
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //on met 64
	mov cx,127 //on met 128
	sub si,y //On enleve y   //4
	sub cx,x //On enleve x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov ch,1   //On met le state    //2
	shl ch,cl     //on le deplace selon cl //3
	xor es:[si],ch}}; //On l'applique a l'octet //7
#endif

/*==============================================================
in :	coordonnes
		page (1 -> 4)
out:	couleur 1->Noir, 0->Blanc
rem:	retourne la couleur du pixel spsifi
===============================================================*/
#ifdef KFUNC_CASIO_tstpixel
char tstpixel(int X, int Y,int page) {
asm {	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //on met 64
	mov cx,127 //on met 128
	sub si,Y //On enleve y   //4
	sub cx,X //On enleve x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov al,es:[si];
	ror al,cl;
	and al,1; }
return _AL; }
#endif

/*==============================================================
in :	page (1 -4)
out:
rem:	efface le buffer vido spcifi par page
by :	Whyp
===============================================================*/
#ifdef KFUNC_CASIO_clearpage
void clearpage(short page) {
int i;
asm mov ax,page;
asm shl ax,6;
asm add ax,0x1A20;
asm mov es,ax;
asm xor ax,ax;
for (i=0;i<1024;i+=2){
	_SI=i;
	asm mov es:[si],ax; } }
#endif

/*==============================================================
in :
out:	No de page courante
rem:	Prens la page courante
by :	Superna
===============================================================*/
#ifdef KFUNC_CASIO_getpage
int getpage(void) {
	short sEgMt=peek(0x4E,0); // Recupere le segment
	return ((sEgMt-0x1A20)/0x40);}
#endif

/*==============================================================
in :	page
out:
rem:	Prends un Screenshot
by :	Y@SS
===============================================================*/
#ifdef KFUNC_CASIO_shootpage
int shootpage(short page) {
unsigned int segm_video=0x1A20+(page*0x40);
unsigned long adresse;
unsigned int found=0, b=0,  offset, progseg, segment;
unsigned char realname[6];
progseg=0x1A20 + 0x200;
strcpy((unsigned char *)(realname), "HCOPY1");
for(segment=progseg; segment < (progseg + 10000); segment++) {
	for (offset=0; offset < 16; offset++) {
	if (((unsigned char)peekb(segment, offset)) == ((unsigned char)realname[b])) {
		b++;
		if (b==5) {
			found=1;
			break; } }
	else {
		if (b) {
			b=0;
			offset--; } } }
	if(found) break; }
	if (!found) {
		return (-1); }
b--; b--;
b += 3;
adresse=((unsigned long)segment) * 16 + offset;
segment=((adresse ) - (adresse )%16 )/16;
offset= (adresse )%16;
offset+=3;
for(b=0;b<=1024;b++) pokeb( segment , offset+b , peekb (segm_video, b));
return 1; }
#endif

/*==============================================================
in :	page
out:
rem:	Met la page voulue
by :	Libthium
===============================================================*/
#ifdef KFUNC_CASIO_setpage
void setpage(short page){
	asm{
	mov ax,page
	shl ax,6
	add ax,0x1A20
	xor dx,dx
	shl ax,1
	rcl dx,1
	shl ax,1
	rcl dx,1
	shl ax,1
	rcl dx,1
	shl ax,1
	rcl dx,1
	out 0x05,ax
	mov al,dl
	out 0x07,al } }
#endif

/*==============================================================
in :	coordonnes
		page
out:
rem:	Dessine une ligne Horizontale
by :	Duobab
===============================================================*/
#ifdef KFUNC_CASIO_hline2
void hline2(int x1, int x2, int y,int page , int state)
	{int i;for(i=x1; i<=x2;i++) setPix(i,y,page,state) ;}
#endif

/*==============================================================
in :	coordonnes
		page
out:
rem:	Dessine une ligne Verticale
by :	Duobab
===============================================================*/
#ifdef KFUNC_CASIO_vline2
void vline2(int y1, int y2, int x,int page , int state)
	{int i;for(i=y1; i<=y2;i++) setPix(x,i,page,state) ;}
#endif

/*==============================================================
in :	coordonnes
		page
out:
rem:	Dessine un rectangle
by :	Duobab
===============================================================*/
#ifdef KFUNC_CASIO_rect
void rect(int x1,int y1,int x2,int y2, int page, int state)
	{hline2(x1,x2,y1,page,state);
	hline2(x1,x2,y2,page,state);
	vline2(y1,y2,x1,page,state);
	vline2(y1,y2,x2,page,state);}
#endif

/*==============================================================
in :	coordonnes
		page
out:
rem:	Rempli un rectangle
by :	Duobab
===============================================================*/
#ifdef KFUNC_CASIO_fillRect
void fillRect(int x1,int y1,int x2,int y2,int page,int state)
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			setPix(i,j,page,state);}
#endif

/*==============================================================
in :	coordonnes
		page
out:
rem:	Inverse un rectangle
by :	Superna
===============================================================*/
#ifdef KFUNC_CASIO_invRect
void invRect(int x1,int y1,int x2,int y2,int page)
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			invpixel(i,j,page);}
#endif

/*==============================================================
in :	page
out:
rem:	Inverse l'ecran
by :	2072
===============================================================*/
#ifdef KFUNC_CASIO_invpage
void invpage(int page){
int x,seg;
asm shl page,6;
asm add page,0x1a20;
seg=page;
for (x=0; x<0x200; x++)
poke(seg, x << 1, peek(seg, x << 1) ^ 0xFFFF);}
#endif

/*==============================================================
in :	page source
		page target
out:
rem:	Copy la page source a la page target
by :	Superna
===============================================================*/
#ifdef KFUNC_CASIO_copypage
void copypage(int source ,int target){asm{
	push ds
	mov ax,target
	shl ax,6
	add ax,0x1A20
	mov es,ax
	mov di,0
	mov ax,source
	shl ax,6
	add ax,0x1A20
	mov ds,ax
	mov si,0
	cld
	mov cx,512
	rep movsw
	pop ds};}
#endif

/*==============================================================
in :
out:	no de touche
rem:	Attends une touche pressee et la retourne
===============================================================*/
#ifdef KFUNC_CASIO_waitkey
unsigned int waitkey()
	{unsigned int v=peekb(0x40,0xAF);
	if (v==0) v=getch();
	return v;}
#endif

/*==============================================================
in :	touche attendue
out:
rem:	Attends la touche attendue pressee
===============================================================*/
#ifdef KFUNC_CASIO_waitakey
void waitakey(unsigned int k)
	{unsigned int v;
	do{v=getch();if (v==0) v=peekb(0x40,0xAF);}
	while(v!=k);}
#endif

/*==============================================================
in :	coordonnes
		string
out:
rem:	affiche du text a un endroit de l'afficheur
===============================================================*/
#ifdef KFUNC_CASIO_locate
void locate(int x,int y,char st[]){
	gotoxy(x,y);
	printf(st);}
#endif

/*==============================================================
in :	valeur d'attente
out:
rem:	attente
===============================================================*/
#ifdef KFUNC_CASIO_wait
void wait(long t){long i;
	for (i=0; i<=t*100;i++);}
#endif

/*==============================================================
in :
out:	touche press
rem:	retourne la touche press
By :	Vic
===============================================================*/
#ifdef KFUNC_CASIO_getkey
unsigned int  getkey()
{unsigned char tch;
tch = peekb(0x40,0xAF);
return (tch);
}
#endif

/*==============================================================
in :
out:
rem:	Eteint la calculatrice
by :	Whyp
===============================================================*/
#ifdef KFUNC_CASIO_shutcalc
void shutcalc(){
asm mov al,0x08;
asm out 0x0C,al;}
#endif

/*==============================================================
in :
out:
rem:	Fait rebooter la calculatrice
by :	Bugbug et BradN
===============================================================*/
/*#ifdef KFUNC_CASIO_rebootcalc
void rebootcalc()
{PtrReboot =(void * far) MK_FP(0xFFFF,0x0000);
(*PtrReboot) ();
}
#endif
*/

/*==============================================================
in :
out:
rem:	Contraste plus fonc
by :	WHYP
===============================================================*/
#ifdef KFUNC_CASIO_contplus
void contplus(){
asm{mov bl,0
mov ah,0x22
int 0x7C};};
#endif

/*==============================================================
in :
out:
rem:	Contraste plus clair
by :	WHYP
===============================================================*/
#ifdef KFUNC_CASIO_contless
void contless(){
asm{mov bl,1
mov ah,0x22
int 0x7C};};
#endif

/*==============================================================
in :	1:Heure 2:Minute 2:Secondes
out:	heure ou minute ou secondes
rem:	Retourne l'info temporelle demand
by :	Niff
===============================================================*/
#ifdef KFUNC_CASIO_get_time
unsigned char get_time(unsigned char what){
if(what!=1&&what!=2&&what!=3) return 0;
asm {
xor ax,ax
mov dx,0x0020
mov al,what
sub dx,ax
in al,dx };
return _AL; }
#endif

/*==============================================================
in :	1:Heure 2:Minute 2:Secondes, valeur
out:
rem:	rglage de l'horloge
		temps entre 0 et 59 (les secondes se mettent a 0)
by :	Niff
===============================================================*/
#ifdef KFUNC_CASIO_set_time
unsigned char set_time(unsigned char what,unsigned char time){
if(what!=1&&what!=2) return 0;
if(time>59) return 0;
asm{
xor ax,ax
mov dx,0x0020
mov al,what
sub dx,ax
mov al,time
out dx,al
hlt
mov al,0x03
sub al,what
out 0x1D,al };
return 1; }
#endif

/*==============================================================
in :	what:0=[Jours] 1=[Mois] 2=[annee] 3=[njour]
		jours:0=[si de la caltos] sinon=[jours ecoules depuis le 1/1/2000]
out:	jour ou mois ou anne
rem:	Retourne la date
		njour:0=Lundi -> 6=Dimanche
By :	Niff
===============================================================*/
#ifdef KFUNC_CASIO_get_date
unsigned short get_date(unsigned char what, unsigned short jours){
	unsigned char mois[12]={31,28,31,30,31,30,31,31,30,31,30,31};
	unsigned char nyear=0,byear=0,month=0,day=0;
if(jours==0){ asm in ax,0x20;jours=_AX;}
day=jours%7+5;if(day>6) day-=7;
if(what==3) return day;
if(jours>=366){
byear=(((jours-366)/365)/4)+1;
nyear=jours/365;}
if(what==2) return (2000+nyear);
if(nyear%4==0) mois[1]=29;
jours-=(nyear*365)+byear;
debct:
if(jours>=mois[month]){ jours-=mois[month];
	month++;
	goto debct; }
if(what==1) return (month+1);
return (jours+1); }
#endif

/*==============================================================
in :	year:[2000;2158] month:[1;12] days:[0;31]
		Retourne le nombre de jours depuis 1/1/2000
out:	nombre de jours
rem:	Regle la date
===============================================================*/
#ifdef KFUNC_CASIO_set_date
unsigned short set_date(short year,char month,char days){
	unsigned char mois[12]={31,28,31,30,31,30,31,31,30,31,30,31};
	unsigned char byear=0;
	unsigned short total;
year-=2000;month--;days--;
byear=(year-1)/4;
if(year>0) byear++;
total=(year*365)+byear;
if(year%4==0) mois[1]=29;
for(byear=0;byear<month;byear++) total+=mois[byear];
if(days>mois[month]) total+=mois[month];
else total+=days;
_AX=total;
asm out 0x20,ax;
asm mov al,4;
asm out 0x1d,al;
return total;}
#endif

/*==============================================================
in :
out:
rem:	affichage d'une bitmap
By :	Whyp et Roeoender
===============================================================*/
#ifdef KFUNC_CASIO_disp_bmp
void disp_bmp (BMPTabType BmpTab,int page) {
asm{ mov ax,page
     shl ax,6
     add ax,0x1a20
     mov es,ax
     mov si,offset BmpTab
     xor di,di
     mov cx,0x200
     cld
     rep movsw } }
#endif
