/*=====================================================================
CASIO 3.0

 All these routines works with Video Pages to work with Multi-Buffering
    Part of Na-Prod Casio Project & CDK & Graph100 French Network
  Thanks to Whyp, 2072, BradN, Y@SS, Bugbug, Libthium, Duobab, Roeoender
  	New Pixel Routines by SUPERNA, 27% faster than old ones
   New exclusives routines : Time, date, contrast, On/Off and Reboot !
 	See .doc for help and examples or www.na-prod.com

======================================================================*/

#if !defined CASIO_LIB
#define CASIO_LIB



#define DATA_SIZE 1024

typedef unsigned char BMPTabType [DATA_SIZE];

//=======================================================================
//=======  Choix des fonctions a compiler dans le projet ================
//=======================================================================

//Mettre les fonctions non utilise en commentaire seulement ici

#define	KFUNC_CASIO_setPix
//#define	KFUNC_CASIO_setbPix
//#define	KFUNC_CASIO_setwPix
//#define	KFUNC_CASIO_invpixel
//#define	KFUNC_CASIO_tstpixel
#define	KFUNC_CASIO_clearpage
//#define	KFUNC_CASIO_getpage
//#define	KFUNC_CASIO_shootpage
#define	KFUNC_CASIO_setpage
//#define	KFUNC_CASIO_hline2
//#define	KFUNC_CASIO_vline2
//#define	KFUNC_CASIO_rect
//#define	KFUNC_CASIO_fillRect
//#define	KFUNC_CASIO_invRect
//#define	KFUNC_CASIO_invpage
//#define	KFUNC_CASIO_copypage
#define	KFUNC_CASIO_waitkey
#define	KFUNC_CASIO_waitakey
//#define	KFUNC_CASIO_locate
#define	KFUNC_CASIO_wait
#define	KFUNC_CASIO_getkey
//#define	KFUNC_CASIO_shutcalc
//#define	KFUNC_CASIO_rebootcalc
//#define	KFUNC_CASIO_contplus
//#define	KFUNC_CASIO_contless
//#define	KFUNC_CASIO_get_time
//#define	KFUNC_CASIO_set_time
//#define	KFUNC_CASIO_get_date
//#define	KFUNC_CASIO_set_date
//#define	KFUNC_CASIO_disp_bmp

//=========================================================================
//======================= dfinitions de touches =========================
//=========================================================================

#define K_MENU		15
#define K_F1		59
#define K_F2		60
#define K_F3		61
#define K_F4		62
#define K_F5		63
#define K_F6		64
#define K_SHIFT		42
#define K_CTRL		29
#define K_OPTN		58
#define K_GAUCHE	75
#define K_DROITE	77
#define K_HAUT		72
#define K_BAS		80
#define K_ALPHA		56
#define K_VARS		70
#define K_PUISS		14
#define K_ESC		1
#define K_X			30
#define K_LOG		48
#define K_LN		46
#define K_SIN		32
#define K_COS		18
#define K_TAN		33
#define K_DC		34
#define K_X2		35
#define K_CRH_G		23
#define K_CRH_D		36
#define K_VIRG		37
#define K_FLECHE	38
#define	K_7			8
#define	K_8			9
#define	K_9			10
#define K_DEL		83
#define K_ACon		69
#define	K_4			5
#define	K_5			6
#define	K_6			7
#define K_FOIS		31
#define K_DIVIS		20
#define	K_1			2
#define	K_2			3
#define	K_3			4
#define K_PLUS		45
#define K_MOINS		21
#define	K_0			11
#define K_POINT		52
#define K_EXP		82
#define K_TIRET		12
#define K_EXE		28


//=====================================================================
//===================== prototypes des fonctions ======================
//=====================================================================

void setPix(short X,short Y,short page,unsigned char couleur);
void setbPix(short x,short y,short page);
void setwPix(int x,int y,int page);
void invpixel(int x,int y,int page);
char tstpixel(int X, int Y,int page);
int getpage(void);
int shootpage(short page);
void setpage(short page);
void hline2(int x1, int x2, int y,int page , int state);
void vline2(int y1, int y2, int x,int page , int state);
void rect(int x1,int y1,int x2,int y2, int page, int state);
void fillRect(int x1,int y1,int x2,int y2,int page,int state);
void invRect(int x1,int y1,int x2,int y2,int page);
void invpage(int page);
void copypage(int source ,int target);
unsigned int waitkey();
void waitakey(unsigned int k);
void locate(int x,int y,char st[]);
void wait(long t);
unsigned int  getkey();
void shutcalc();
void rebootcalc();
void contplus();
void contless();
unsigned char get_time(unsigned char what);
void (far * PtrReboot) (void);
unsigned char set_time(unsigned char what,unsigned char time);
unsigned short get_date(unsigned char what, unsigned short jours);
unsigned short set_date(short year,char month,char days);
void disp_bmp (BMPTabType BmpTab,int page);


#endif
