 /////////////////////////////////////////////////////////////////////////////////////
//*						   <DrawLib pour CASIO Graph100>						    *//
//																					 //
//				 Fichier d'entete a inclure dans les fichiers contenant				 //
//                des fonctions qui utilisent des fonctions de la lib                //
//											                                         //
//*  Version 1.4b										   (c) Julien PATTE - 2004  *//
 /////////////////////////////////////////////////////////////////////////////////////

#if !defined __DRAWLIB
#define __DRAWLIB

typedef unsigned char uchar;

///////////////////////////////////////////////////////////////////////////////////////

	// Segment du premier buffer (def: 0x1A60)

#define DRAW_BUFFER1 0x1A60

	// Espace entre les dbuts de chaque buffer (def: 2048 => segment 0x1AE0)

#define DRAW_JUMP    2048

	// Limites (en pixels) de clipping gauche et droite

#define DRAW_CLIPG   0   //(0 <= x <= 127)
#define DRAW_CLIPD   128  //(1 <= x <= 128)

	// Limites (en pixels) de clipping haut et bas

#define DRAW_CLIPH   0	  //(0 <= x <= 63)
#define DRAW_CLIPB   64	  //(1 <= x <= 64)

///////////////////////////////////////////////////////////////////////////////////////

	// Fonctions  compiler
	// NE SUPPRIMEZ PAS CES 5 MACROS,
	// mettez en commentaires les define correspondants aux fonctions dont vous n'avez pas besoin.

#define FUNC_DRAWSPR
//#define FUNC_SIZESPRITE
#define FUNC_DRAW_NOMASK_NOCLIP
#define FUNC_DRAW_MASK_NOCLIP
#define FUNC_DRAW_NOMASK_CLIP
#define FUNC_DRAW_MASK_CLIP

///////////////////////////////////////////////////////////////////////////////////////

	// Macros  passer comme 4eme argument de drawspr pour spcifier le type d'affichage

#define MODE_NOMASK_NOCLIP 0
#define MODE_MASK_NOCLIP   1
#define MODE_NOMASK_CLIP   2
#define MODE_MASK_CLIP     3

///////////////////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C" {
#endif

	// Fonction principale de la lib ( utiliser en priorit)

void drawspr(int x, char y, void far* spr, uchar mode);

	// Fonctions correspondant  chaque mode possible

void draw_noM_noC (int x,char y,void far* spr); // no mask, no clip
void draw_M_noC	  (int x,char y,void far* spr); //    mask, no clip
void draw_noM_C   (int x,char y,void far* spr); // no mask,    clip
void draw_M_C     (int x,char y,void far* spr); //    mask,    clip

	// Retourne le nombre d'octets necessaires pour coder un sprite
	// de hauteur Haut et de largeur Larg

int sizesprite(uchar Haut,uchar Larg);

	// Appel compatible avec les appels de DrawLib 1.3

#define drawsprite(a,b,c) draw_M_C(a,b,c)

#ifdef __cplusplus
}
#endif


///////////////////////////////////////////////////////////////////////////////////////

#endif
