#include "fonx.h"

void clearbuff()
{
asm {
	mov ax,0x1A60
	mov es,ax
	xor di,di		// adresse du buffer dans es
	mov cx,512		// on copie 512 mots
	xor ax,ax		// valeur a copier ( 0 ) dans ax
	cld				// incrmentation automatique de di  chaque stosw
	rep stosw		// on copie cx fois le contenu de ax a l'adresse es:di ---> efface la 1ere page
	add di,1024		// saute une page pour recommencer sur le 2eme buffer
	mov cx,512		// on remet le compteur cx a 512
	rep stosw		// ---> efface la 2eme page
	}
}

///////////////////////////////////////////////////////////////////////////////////////

void modevideo(uchar on)
{
   static uchar cont_init=get_cont();      // contraste initial

asm {
	cmp on,0
	je mode_off

	mov al,0xdb			// active le mode DB
	mov dl,18			// contraste a 18
	jmp mode_set

} mode_off: asm {

	mov al,0xc3			// restaure le mode C3
	mov dl,cont_init	// remet le contraste initial

} mode_set:

	asm out 2,al;
	contrast(_DL);
}

///////////////////////////////////////////////////////////////////////////////////////

/*uchar testkey(uchar ligne,uchar colonne)
{			// teste une touche particulire et renvoie 0 si cette touche n'est pas presse
			// touches multiples acceptes
asm	{
	mov ax,1
	mov cl,ligne
	shl ax,cl		// ax = 2^ligne
	out 0x13,ax
	mov cx,10
} key_loop: asm {
    loop key_loop
	in al,0x13		// la valeur du port a change si une touche est pressee
	mov ah,1
	mov cl,colonne
	shl ah,cl		// ah = 2^colonne
	and al,ah		// on ne garde que la valeur du bit a observer
	}
	return _AL;
}
*/
///////////////////////////////////////////////////////////////////////////////////////

void refresh()
{
	/* REFRESH: BUFFERS --> ECRAN: Buffer1 --> 0x1A20
								   Buffer2 --> 0x1AA0         */
asm {
	push ds
	mov cx,0x1A60
	mov ds,cx		// adresse du premier buffer dans ds
	xor si,si
	mov cx,0x1A20
	mov es,cx		// adresse de la premiere page video (0x1A20) dans es
	xor di,di
	mov cx,512		// il faut copier 512 mots
	cld				// incrmentation automatique de di et de si  chaque movsw
	rep movsw		// copie cx mots de ds:si a es:di ( premiere page )
	add di,1024
	add si,1024		// saute une page
	mov cx,512		// remet le compteur  512
	rep movsw		// copie la deuxieme page
	pop ds
	}
}

///////////////////////////////////////////////////////////////////////////////////////

// Fonction extraite de DB-Lib.h par Swifter.
uchar get_cont()
{
asm {
	mov ax,0x40
	mov es,ax
	mov al,es:0xE5
	sub al,0x12
	shr al,1
	}
	return _AL;
}


///////////////////////////////////////////////////////////////////////////////////////

// Fonction extraite de DB-Lib.h par Swifter.
void contrast(uchar niv)
{
asm {
	mov ax,0x40       // =============
	mov es,ax         // |g100 |g100+|
	mov al,niv        // =============
	shl al,1          // |  0  |  0  |  contraste minimal
	add ax,0x2210     // |  8  |  9  |  contraste normal
	mov es:0xE5,al    // |  12 |  12 |  contraste initial
	xor bl,bl         // |  15 |  16 |  contraste optimal pour le gris
	int 0x7C          // |  22 |  22 |  contraste maximal
	}                 // =============
}


